from statistics import mean, variance
import matplotlib.pyplot as plt
from mpl_toolkits import mplot3d
import random
import math
import numpy as np

tasknumber = int(input("Digit a task number ---> "))
directory = "REMODEL_WP5-T4-3_UNIBO_"
with open(directory+"path"+str(tasknumber)+".txt", "r") as file:
    lines = file.readlines()
file.close()

with open(directory+"Forces"+str(tasknumber)+".txt", "r") as F:
    Forces_str = F.readlines()
F.close()

def readforces(LL):
    FF = []
    collect = 0
    for L in LL:
        F = []
        for el in L:
            if collect == 1:
                if el != "," and el != "]":
                    value += el
                elif el == ",":
                    F.append(float(value))
                    value = ""
                else:
                    F.append(float(value))
                    FF.append(F)
                    collect = 0 
            if el == "[":
                collect = 1
                value = ""
    return FF

def readline(line):
    value = ""
    doublea = ""
    trajs = []
    collect = False
    trajectoriesin = False
    scoresin = False
    for a in line:
        if trajectoriesin:
            doublea += a
            if doublea == "]]":
                trajectoriesin = False
            else:
                doublea = a
                if a == "[":
                    traj = []
                elif a == "]":
                    trajs.append(traj)
                elif a == "(":
                    point = []
                    collect = True
                    val = ""
                elif a == ")":
                    point.append(int(val))
                    val = ""
                    traj.append(tuple(point))
                    collect = False
                else:
                    if not(a=="," or a==" " or a=="\n"):
                        val += a
                    elif a=="," and collect:
                        point.append(int(val))
                        val = ""
        elif scoresin:
            if a == "[":
                scores = []
            elif a == "]":
                scores.append(float(val))
                scoresin = False
            else:
                if not(a=="," or a==" " or a=="\n"):
                    val += a
                elif a==",":
                    scores.append(float(val))
                    val = ""
        else:
            value += a
            if value == "Trajectories:":
                value = ""
                trajectoriesin = True
            elif value == "Scores:":
                value = ""
                scoresin = True
    return (trajs,scores)

def filter(L,Flen=20):
    Filtered = []
    for i in range(len(L)):
        if len(L[:i])<Flen:
            Filtered.append(mean(L[:i+1]))
        else:
            Filtered.append(mean(L[i+1-Flen:i+1]))
    return Filtered

colors = ["red","yellow","purple","green","blue","black","pink","orange","gray","brown"]

TrajectoriesExplored = []
ScoresObtained = []

Forces = readforces(Forces_str)
count = 0
numberOfGray = 30
for i in range(1,len(Forces)):
    if i<len(Forces)-1:
        count += 1
        if 10>mean(Forces[i])>2 and count >= int(len(Forces)/numberOfGray):
            plt.plot(filter(Forces[i],50), "grey", linewidth=1)
            last = Forces[i]
            count = 0
    else:
        plt.plot(filter(Forces[0],50), "red", linewidth=4)
        print("starter traj peak --->  ", max(filter(Forces[0],50)))
        print("starter traj mean --->  ", mean(filter(Forces[0],50)))
        print("starter traj variance --->  ", np.var(filter(Forces[0],50)))
        scoreI = variance(filter(Forces[0],50))*max(filter(Forces[0],50))*mean(filter(Forces[0],50))
        print("starter traj mean*variance*Fmax --->  ", scoreI)
        if 10>mean(filter(Forces[i]))>2:
            plt.plot(filter(filter(Forces[i]),50), "green", linewidth=4)
            print("result traj peak --->  ", max(filter(Forces[i],50)))
            print("result traj mean --->  ", mean(filter(Forces[i],50)))
            print("result traj variance --->  ", np.var(filter(Forces[i],50)))
            scoreL = variance(filter(Forces[i],50))*max(filter(Forces[i],50))*mean(filter(Forces[i],50))
            print("result traj mean*variance*Fmax --->  ", scoreL)
        else:
            plt.plot(filter(last,50), "green", linewidth=4)
            print("result traj peak --->  ", max(filter(last,50)))
            print("result traj mean --->  ", mean(filter(last,50)))
            print("result traj variance --->  ", np.var(filter(last,50)))
            scoreL = variance(filter(last,50))*max(filter(last,50))*mean(filter(last,50))
            print("result traj mean*variance*Fmax --->  ", scoreL)
        print("IMPROVEMENT: ", ((1/scoreL)-(1/scoreI))/(1/scoreI))

plt.xlabel("Step")
plt.ylabel("Force [N]")
plt.grid()
#plt.savefig('/Users/dotta/OneDrive/Desktop/Dottorato/work/SBPL paper/Images/forces'+str(tasknumber)+'.eps', bbox_inches='tight')
plt.show()

for line in lines:
    T,S = readline(line)
    for t in T:
        TrajectoriesExplored.append(t)
    for s in S:
        ScoresObtained.append(s)
    
So = []
step = 0
for i,s in enumerate(ScoresObtained):
    if i > 3:
        if (i+1)%4==1:
            step += 1
        So.append(s+max(So[0:step*4-1]))
    else:
        So.append(s)

ScoresObtained = So

indexes_outofbound = []
for idx,s in enumerate(ScoresObtained.copy()):
    if s < -1:
        indexes_outofbound.append(idx)
indexes_outofbound.reverse()
for idx in indexes_outofbound:
    ScoresObtained.pop(idx)
    TrajectoriesExplored.pop(idx)

for i in range(len(ScoresObtained)-1):
    if ScoresObtained[i+1]>0:
        plt.plot([i,i+1],[100*ScoresObtained[i],100*ScoresObtained[i+1]],"green")
    else:
        plt.plot([i,i+1],[100*ScoresObtained[i],100*ScoresObtained[i+1]],"red")

so = [100*e for e in ScoresObtained]
plt.plot(filter(so,20), "blue", linewidth=0.5)

plt.title("Scores")
plt.xlabel("Episode Number")
plt.ylabel("Percentual Improvement %")
plt.grid()
plt.show()

ax = plt.axes(projection='3d')
for traj in TrajectoriesExplored:
    xline = []
    yline = []
    zline = []
    for point in traj:
        rndcolor = random.choice(colors)
        zline.append(point[2])
        yline.append(point[1])
        xline.append(point[0])
        ax.plot3D(xline, yline, zline, color=rndcolor)
plt.title("Trajectories\n"+str(len(TrajectoriesExplored))+" Performed")
plt.show()